namespace PkmnLib.Plugin.Gen7.Scripts.Abilities;

/// <summary>
/// Magic Bounce is an ability that reflects status moves back to the user.
///
/// <see href="https://bulbapedia.bulbagarden.net/wiki/Magic_Bounce_(Ability)">Bulbapedia - Magic Bounce</see>
/// </summary>
[Script(ScriptCategory.Ability, "magic_bounce")]
public class MagicBounce : Script, IScriptChangeIncomingTargets
{
    /// <inheritdoc />
    public void ChangeIncomingTargets(IMoveChoice moveChoice, ref IReadOnlyList<IPokemon?> targets)
    {
        if (moveChoice.ChosenMove.MoveData.HasFlag(MoveFlags.Reflectable))
        {
            var target = targets[0];
            target?.BattleData?.Battle.EventHook.Invoke(new AbilityTriggerEvent(target));
            targets = [moveChoice.User];
        }
    }
}